/*!
 * \file    CChildView.cpp
 * \brief   Implementation of CChildView
 * \author  shinyak
 *
 * $Id$
 * Copyright (C) 2005- Shinya KAWANAKA All Rights Reserved.
 */

#include "stdafx.h"
#include "JShark.h"
#include "CChildView.h"
#include "CSharkKeyBoard.h"
#include "CDebugNew.h"

BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
    ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()

CChildView::CChildView()
{
    m_isButtonPressing = false;
}

CChildView::~CChildView()
{
    // NOTHING_TO_DO()
}


BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
    if (!CWnd::PreCreateWindow(cs)) { return FALSE; }

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS, 
	                                   ::LoadCursor(NULL, IDC_ARROW),
                                       reinterpret_cast<HBRUSH>(COLOR_WINDOW+1),
                                       NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	// ATTNETION: bZ[W̕`̂߂ CWnd::OnPaint() ĂяoȂłB

    // TODO: _uobt@Og

    // `̃foCX ReLXg
    CPaintDC dc(this);
	
    CSharkKeyboardManager::Instance().DrawKeyboard(&dc);
}

void CChildView::OnMouseMove(UINT nFlags, CPoint point)
{
    if (!m_isButtonPressing) { return; }

    BOOST_ASSERT(!m_orbit.empty());

    if (CDC* pDC = GetDC()) {
        pDC->MoveTo(m_orbit.back());
        pDC->LineTo(point);
        ReleaseDC(pDC);
    } else {
        ASSERT_NOT_REACHED();
    }

    m_orbit.push_back(point);
}

void CChildView::OnLButtonDblClk(UINT nFlags, CPoint point)
{
    CChildView::OnLButtonDown(nFlags, point);
}

void CChildView::OnLButtonDown(UINT nFlags, CPoint point)
{
    m_isButtonPressing = true;
    m_orbit.clear();
    m_orbit.push_back(point);
    SetCapture();
}

void CChildView::OnLButtonUp(UINT nFlags, CPoint point)
{
    m_orbit.push_back(point);
    m_isButtonPressing = false;

    ReleaseCapture();

    CSharkKeyboardManager::Instance().Recognize(m_orbit);
    m_orbit.clear();

    InvalidateRect(NULL); // repaint
}