/*!
 * \file    CFreqDictionary.h
 * \brief   px
 * \author  shinyak
 * 
 * $Id$
 * Copyright (C) 2005- Shinya KAWANAKA All Rights Reserved.
 */

#pragma once

class CFreqDictionaryManager
{
private:
    CFreqDictionaryManager(void);
    ~CFreqDictionaryManager(void);

public:
    static CFreqDictionaryManager& Instance();

public:
    void LoadDictionary();
    void SaveDictionary() const;

public:
    int GetFrequency(const CString& str) const;
    int GetAllFrequence() const { return m_allFreq; }
public:
    void UpFrequency(const CString& str);
    void DownFrequency(const CString& str);

private:
    static const CString    s_dictFilename;
    std::map<CString, int>  m_freq;
    int                     m_allFreq;
};
