/*!
 * \file    CMainFrame.cpp
 * \brief   Implementation of JShark class.
 * \author  shinyak
 *
 * $Id$
 * Copyright (C) 2005- Shinya KAWANAKA All Rights Reserved.
 */

#include "StdAfx.h"
#include "JShark.h"
#include "Resource.h"
#include "CMainFrame.h"
#include "CSharkKeyboard.h"
#include "CDebugNew.h"

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_WM_CONTEXTMENU()
	ON_WM_MOUSEACTIVATE()
	ON_WM_ACTIVATE()
	ON_WM_TIMER()
END_MESSAGE_MAP()

const UINT_PTR  CMainFrame::JSHARK_TIMER_ID = 2035;
const int       CMainFrame::JSHARK_TIMER_INTERVAL = 100;

CMainFrame::CMainFrame() :
    m_attachedThreadID(0)
{
    // NOTHING_TO_DO()
}

CMainFrame::~CMainFrame()
{
    // NOTHING_TO_DO()
}

void CMainFrame::TimerStart()
{
    SetTimer(JSHARK_TIMER_ID, JSHARK_TIMER_INTERVAL, NULL);
}

void CMainFrame::TimerStop()
{
    KillTimer(JSHARK_TIMER_ID);
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1) { return -1; }

	// t[̃NCAg̈Ŝ߂r[쐬܂B
	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		                  CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("r[ EBhE쐬ł܂łB\n");
		return -1;
	}
    
    // L[{[hȂǂCjVCY܂B
    Initialize();

	return 0;
}


void CMainFrame::Initialize()
{
    m_contextMenu.LoadMenu(IDR_CONTEXTMENU);
    TimerStart();
}


BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
    if (!CFrameWnd::PreCreateWindow(cs)) { return FALSE; }

    cs.cx = 800;
    cs.cy = 500;
	cs.style = WS_OVERLAPPED | WS_CAPTION | FWS_ADDTOTITLE | WS_SYSMENU;
#ifndef _DEBUG
	cs.dwExStyle |= WS_EX_TOPMOST;
#endif
	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);

	return TRUE;
}


void CMainFrame::OnSetFocus(CWnd* /*pOldWnd*/)
{
	m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// r[ɍŏɃR}h@^܂B
    if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo)) { return TRUE; }

	// ȊȌꍇ́Ȁs܂B
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CMainFrame::OnContextMenu(CWnd* pWnd, CPoint point)
{
	CMenu* pPopup = m_contextMenu.GetSubMenu(0);
	
	ASSERT_NOT_NULL(pPopup);
	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, AfxGetMainWnd());
}

int CMainFrame::OnMouseActivate(CWnd* pDesktopWnd, UINT nHitTest, UINT message)
{
	TRACE(_T("OnMouseActivate comes : "));
    
    return MA_NOACTIVATE;
}

void CMainFrame::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized)
{
	TRACE(_T("OnActivate comes\n"));

	CFrameWnd::OnActivate(nState, pWndOther, bMinimized);
}

void CMainFrame::OnTimerAux()
{
    CWnd* pWnd = GetForegroundWindow();
    if (pWnd == NULL) { return; }

    // Thread A^b`BŁAActive Window ύXȂȂB
    // A^b`ĂƁAIME ̓͂HĎcOȂƂɂȂB
	DWORD focusThreadID = ::GetWindowThreadProcessId(::GetForegroundWindow(), NULL);
    
    if (m_attachedThreadID != focusThreadID) {
        m_attachedThreadID = focusThreadID;
        DWORD myThreadID = GetCurrentThreadId();
	    AttachThreadInput(myThreadID, focusThreadID, TRUE);
        Sleep(30);
	    pWnd->SetFocus();
    }

    // ŁAL[{[h̃R}h𑗂B
    CSharkKeyboardManager::Instance().SendInput();
}

void CMainFrame::OnTimer(UINT_PTR nIDEvent)
{
    if (nIDEvent == JSHARK_TIMER_ID) { OnTimerAux(); }

    CFrameWnd::OnTimer(nIDEvent);
}