/*!
 * \file    CMainFrame.h
 * \brief   MainFrame of JShark
 * \author  shinyak
 *
 * $Id$
 * Copyright (C) 2005- Shinya KAWANAKA All Rights Reserved.
 */

#pragma once
#include "CChildView.h"

class CMainFrame : public CFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)	
public:
	CMainFrame();
	~CMainFrame();

public:
	BOOL PreCreateWindow(CREATESTRUCT& cs);
	BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);

public:
    void TimerStart();
    void TimerStop();

private:
	DECLARE_MESSAGE_MAP()
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd *pOldWnd);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg int  OnMouseActivate(CWnd* pDesktopWnd, UINT nHitTest, UINT message);
	afx_msg void OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized);
	afx_msg void OnTimer(UINT_PTR nIDEvent);

private:
    void Initialize();
    void OnTimerAux();

private:
	static const UINT_PTR	JSHARK_TIMER_ID;        //!< Kȃ^C}[̒l
    static const int        JSHARK_TIMER_INTERVAL;  //!< ^C}[C^[o (ms P)

private:
	CChildView				m_wndView;				//!< `Chr[
	CMenu                   m_contextMenu;
    DWORD                   m_attachedThreadID;
};


