/*!
 * \file    CSharkKeyboard.h
 * \brief   JShark Keyboard.
 * \author  shinyak
 *
 * $Id$
 * Copyright (C) 2005- Shinya KAWANAKA All Rights Reserved.
 */

#pragma once
class CSharkKeyboardManagerImpl;

/*!
 * \class   CSharkKeyboardManager
 * \brief   (Reference) JSharkKeyboard
 * \author  shinyak
 */
class CSharkKeyboardManager
{
public:
    CSharkKeyboardManager();
    ~CSharkKeyboardManager();

public:
    static CSharkKeyboardManager& Instance();

public:
    /*!
     * \brief   󔒂gǂ
     */
    void SetAutoSpace(bool autoSpace);

    bool GetAutoSpace() const;

public:
    /*!
     * \brief   pxgǂ
     */
    void SetUseFrequency(bool useFreq);
    bool GetUseFrequency() const;
public:
    /*!
     * \brief   pxL^邩ǂ
     */
    void SetRecFrequency(bool recFreq);
    bool GetRecFrequency() const;

public:
    /*!
     * \brief       Keyboard `悵܂
     * \param[in]   pChildView Keyboard `悳 View
     * \param[in]   pDC pChildView ɕ` DC
     */
    void DrawKeyboard(CDC* pDC) const;

    /*!
     * \brief       orbit FAɂ܂B
     */
    void Recognize(const std::vector<CPoint>& orbit);

    /*!
     * \brief       L[{[hCxg𑗂܂
     */
    void SendInput();


    void GetINPUTOfKey(TCHAR letter, int& outN, INPUT*& outInput);

public:
    /*!
     * \brief   擾܂B
     */
    CSharkKeyboardManagerImpl* GetImpl() const { return m_pImpl.get(); }

private:
    boost::scoped_ptr<CSharkKeyboardManagerImpl>        m_pImpl;
};
