/*!
 * \file    JShark.h
 * \brief   Main Application Class of JShark
 * \author  shinyak
 *
 * $Id$
 * Copyright (C) 2005- Shinya KAWANAKA All Rights Reserved.
 */

#pragma once
class CMainFrame;
class CSharkKeyboard;

/*!
 * \class   JSharkApp
 * \brief   (Reference) Main Application Class of JShark
 * \author  shinyak
 */
class JSharkApp : public CWinApp
{
public:
	JSharkApp();

public:
	BOOL InitInstance();
    int ExitInstance();

public:
    CMainFrame* GetMainFrame() const;

protected:
	afx_msg void OnAppAbout();
    afx_msg void OnJSharkExit();
    afx_msg void OnJSharkAutoSpace();
    afx_msg void OnJSharkAutoSpaceUpdate(CCmdUI* pCmdUI);
    afx_msg void OnJSharkUseFrequency();
    afx_msg void OnJSharkUseFrequencyUpdate(CCmdUI* pCmdUI);
    afx_msg void OnJSharkRecFrequency();
    afx_msg void OnJSharkRecFrequencyUpdate(CCmdUI* pCmdUI);

	DECLARE_MESSAGE_MAP()
};

JSharkApp* GetJSharkApp();

