/*!
 * \file    Utility.cpp
 * \brief   Utility
 * \author  shinyak
 *
 * $Id$
 * Copyright (C) 2005- Shinya KAWANAKA All Rights Reserved.
 */

#include "StdAfx.h"
#include "Utility.h"
#include "CDebugNew.h"

double RoundDifferencial(double r1, double r2)
{
    double r = r2 - r1;

    while (r <= -M_PI) { r += 2 * M_PI; }
    while (r > M_PI)   { r -= 2 * M_PI; }

    return r;
}


bool IsLineIntersection(CPoint s1, CPoint e1, CPoint s2, CPoint e2)
{
    CPoint a = e1 - s1;
    CPoint b = e2 - s2;
    CPoint s = s2 - s1;

    int f = a.x * b.y - a.y * b.x;
    if (f == 0) { return false; } // parallel

    double p = (s.x * b.y - s.y * b.x) / static_cast<double>(f);
    double q = (s.x * a.y - s.y * a.x) / static_cast<double>(f);

    return (0 < p && p <= 1 && 0 < q && q <= 1);
}


CString StringF(LPCTSTR format, ...)
{
    va_list ap;
    va_start(ap, format);

    CString str;
    str.FormatV(format, ap);

    va_end(ap);

    return str;
}


CString GetCurrentDirectorySafely()
{
	TCHAR path[MAX_PATH + 1];

	// st@C̃tpX擾
	::GetModuleFileName(NULL, path, MAX_PATH);

	TCHAR dir[_MAX_DIR + 1];
	TCHAR drive[_MAX_DRIVE + 1];
	TCHAR fname[_MAX_FNAME + 1];
	TCHAR ext[_MAX_EXT + 1];
	::_tsplitpath(path, drive, dir, fname, ext);

	return StringF(_T("%s%s"), drive, dir);
}
